Ruby: pm_constant_path_write_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_constant_path_write_node Struct Reference

ConstantPathWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_constant_path_node * | target
| ConstantPathWriteNode#target.
pm_location_t | operator_loc
| ConstantPathWriteNode#operator_loc.
struct pm_node * | value
| ConstantPathWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ConstantPathWriteNode.

Represents writing to a constant path.

    ::Foo = 1
    ^^^^^^^^^

    Foo::Bar = 1
    ^^^^^^^^^^^^

    ::Foo::Bar = 1
    ^^^^^^^^^^^^^^

Type: ::PM_CONSTANT_PATH_WRITE_NODE

Definition at line 3368 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_constant_path_write_node::base

The embedded base node.

Definition at line 3370 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_constant_path_write_node::operator_loc

ConstantPathWriteNode#operator_loc.

The location of the = operator.

    ::ABC = 123
          ^

Definition at line 3394 of file ast.h.

Referenced by pm_dump_json().

## ◆ target

struct pm_constant_path_node* pm_constant_path_write_node::target

ConstantPathWriteNode#target.

A node representing the constant path being written to.

    Foo::Bar = 1
    ^^^^^^^^

    ::Foo = :abc
    ^^^^^

Definition at line 3384 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_constant_path_write_node::value

ConstantPathWriteNode#value.

The value to write to the constant path. It can be any non-void expression.

    FOO::BAR = :abc
               ^^^^

Definition at line 3404 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h